﻿CREATE OR ALTER PROCEDURE [dbo].[pPers_Sebastian_ShowDailyPresences](
  	@EmployeeId		INT,
	@CurrentUser	INT,
	@RoleId			nvarchar(100),
	@Year			nvarchar(4),
	@Month			nvarchar(2)
)
AS
----------------------------------------------------------------------------------
--#NAME
--		PERS_Sebastian_ShowDailyPresences
--#CREATION
-- 		03/12/2019 - Javier Alcolea
--#CLASIFICATION
-- 		Flexygo/MyStoreds
--#DESCRIPTION
-- 		Stored procedure to get daily presences in Sebastian
--#PARAMETERS
--
--#OBSERVATIONS
-- 		
--#CHANGES
----------------------------------------------------------------------------------
BEGIN TRY

	BEGIN TRAN

	DECLARE @StartDate VARCHAR(8) = CONCAT(@Year,CASE WHEN LEN(@Month) < 2 THEN CONCAT('0',@Month) ELSE @Month END,'01')
	DECLARE @EndDate VARCHAR(8) = CONVERT(varchar, EOMONTH(CAST(CONCAT(@Year,CASE WHEN LEN(@Month) < 2 THEN CONCAT('0',@Month) ELSE @Month END,'01') as datetime)), 112)

    IF @EmployeeId=@CurrentUser OR @RoleId='admins' BEGIN
     		
		SELECT * FROM fun_Dame_Horas_Presencia_Diarias(@EmployeeId,@StartDate,@EndDate) order by Dia
					
    END   
    ELSE 
		BEGIN
			SELECT 'You do Not have enough credentials to view this Object.' as WarningMessage
			ROLLBACK TRAN
			RETURN 1;
		END
	COMMIT

	RETURN 1
END TRY

BEGIN CATCH
	IF @@TRANCOUNT >0 BEGIN
		ROLLBACK TRAN 
	END

	DECLARE @CatchError NVARCHAR(MAX)
	SET @CatchError=ERROR_MESSAGE()
	RAISERROR(@CatchError,12,1)
 
	RETURN 0

END CATCH